//-------------------------------
// Modulo GSM
//
// Coutio Constancio Diana Lizzete
// Ing. Electronica
//
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
char Mbt[3] = {'$','$','$'};  // Comando para inicializacion de modulo BT
char SMbt[3] = {'-','-','-'}; // Comando para finalizar comunicacion con modem BT
char Cbt[16] = {'S','R',',','0','0','0','A','D','9','8','6','6','2','7','D',0x0D}; // Comando para conectar modem BT con MAC de celular
char Connect[2] = {'C',0x0D};  // Comando para conectar modem Bluetooth con celular
char Dbt[4] = {'K',',','I',0x0D};  // Comando para finalizar enlace con celular
char Ntel[10] = {'9','6','1','1','3','8','6','8','9','1'};  // No. Telefonico para enviar SMS
char Send[25] = {'A','T','+','C','M','G','S','=','"','9','6','1','1','3','8','6','8','9','1','"',',','1','2','9',0x0D}; // Comando para envio de SMS
char Read[10] = {'A','T','+','C','M','G','R','=','1',0x0D};  // comando para lectura de SMS
char Delete[10] = {'A','T','+','C','M','G','D','=','1',0x0D};  // comando para borrar un mensaje
char A_on[18] = {'A','L','A','R','M','A',' ','A','C','T','I','V','A','D','A',' ','-',' '};  // Mensaje de alerta del sistema activado
char Formato[10] = {'A','T','+','C','M','G','F','=','1',0x0D};     //formato del texto
char Memoria[13] = {'A','T','+','C','P','M','S','=','"','M','E','"',0x0D};     //formato del texto
//*****************************
unsigned char Rx_Data_Len;      // Longitud de Mensaje recibido
char RxTx_Data[8];              // Buffer para paquete de datos
char RxTx_SMS[8];               // Buffer para recepcion de SMS
unsigned short Msg_Rcvd;        // Bandera indicadora de recpcion de mensaje
unsigned short sms_Rcvd;        // Bandera de recepcion de SMS
char Tx_ID, Rx_ID, Public_ID,Private_ID, ID; // Identificadores de Modulo
int cTx = 0;
int cRx = 0;
int sms_cTx = 0;
int sms_cRx = 0;
unsigned short alarma = 0;        // Variables de uso general
unsigned short retardo_s = 0;
unsigned short retardo_e = 0;
unsigned short retardo_a = 0;
unsigned short sensores = 0;
unsigned short actuadores = 0;
char data = 0;
unsigned short ro = 0;
unsigned short *recOK;
int P1 = 0;        // estado de pnico
int F1 = 0;        // estado de incendio
int I1 = 0;        // estado de inundacin
int E1 = 0;        // estado de emergencia
int A1 = 0;        // estado de la alarma
int cnt=0;
int i;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void interrupt() {
if((PIR1.RCIF == 1) && (RCSTA.OERR == 0) && (cRx <= 7))    // Interrupcion por recepcion de datos  USART
  {
    PORTE.F0 = 1;
    RxTx_Data[cRx] =  Usart_Read();    // lectura de datos USART y transferencia a buffer
    cRx++;
    PORTE.F0 = 0;
    if (cRx == 8)
       {
       Msg_Rcvd = 1;
       Rx_ID = RxTx_Data[6];      // Finalizacion de recepcion de datos
       ID = RxTx_Data[7];
       cRx = 0;
       }
    PIR1.RCIF = 0;
   }
if (PIR1.TMR1IF == 1)          // Interrupcion por temporizacion de TMR1
  {
  cnt++;
  TMR1L = 30;
  TMR1H = 30;
  PIR1.TMR1IF = 0;
  }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Led_Test(){
for (i = 0; i<= 1; i++)  // Indicador de estado de actividad del modulo
    {
    PORTE.F0 = 1;
    Delay_ms(10);
    PORTE.F0 = 0;
    Delay_ms(30);
    PORTE.F0 = 1;
    Delay_ms(10);
    PORTE.F0 = 0;
    PORTE.F1 = 1;
    Delay_ms(10);
    PORTE.F1 = 0;
    Delay_ms(30);
    PORTE.F1 = 1;
    Delay_ms(10);
    PORTE.F1 = 0;
    PORTE.F2 = 1;
    Delay_ms(10);
    PORTE.F2 = 0;
    Delay_ms(30);
    PORTE.F2 = 1;
    Delay_ms(10);
    PORTE.F2 = 0;
    PORTE.F1 = 0;
    PORTE.F0 = 0;
    Delay_ms(500);
    }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Sirena_on(){            // Rutina para la generacion de efecto auditivo de activacion del sistema de seguridad
for (i = 0; i<= 1; i++)
    {
    PORTD.F0 = 1;
    Delay_ms(200);
    PORTD.F0 = 0;
    Delay_ms(800);
    PORTD.F0 = 1;
    Delay_ms(200);
    PORTD.F0 = 0;
    }
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Sirena_off(){            // Rutina para la generacion de seal auditiva para desactivacion del sistema de seguridad
for (i = 0; i<= 1; i++)
    {
    PORTD.F0 = 1;
    Delay_ms(200);
    PORTD.F0 = 0;
    Delay_ms(800);
    PORTD.F0 = 1;
    Delay_ms(200);
    PORTD.F0 = 0;
    Delay_ms(800);
    PORTD.F0 = 1;
    Delay_ms(200);
    PORTD.F0 = 0;
    }
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Modem_Init(){          // Rutina para la inicializacion de la conexion entre Modem BT y Celular
for (i = 0; i <= 2; i++)
    {
    Soft_Uart_Write(Mbt[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 15; i++)
    {
    Soft_Uart_Write(Cbt[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 1; i++)
    {
    Soft_Uart_Write(Connect[i]);
    }
for (i = 0; i <= 2; i++)
    {
    Delay_ms(1000);
    }
for (i = 0; i <= 9; i++)
    {
    Soft_Uart_Write(Formato[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 12; i++)
    {
    Soft_Uart_Write(Memoria[i]);
    }
Delay_ms(1000);
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Clean_Buffer(){     // Rutina para limpiar el buffer de datos
RxTx_Data[0] = 0;
RxTx_Data[1] = 0;
RxTx_Data[2] = 0;
RxTx_Data[3] = 0;
RxTx_Data[4] = 0;
RxTx_Data[5] = 0;
RxTx_Data[6] = 0;
RxTx_Data[7] = 0;
}
//-----------------------------------------------------------------------------
//----------------------------------------------------------------------------
void RF_Write (){       // Rutina para la transmicion de paquetes de datos al modulo Xbee
RxTx_Data[6] = Tx_ID;
for (cTx = 0; cTx <= 7; cTx++)
    {
    Usart_Write(RxTx_Data[cTx]);    // Envio de un paquete de datos
    Delay_ms(5);
    }
cTX = 0;
PORTE.F1 = 1;
Delay_ms(10);
PORTE.F1 = 0;
Delay_ms(30);
PORTE.F1 = 1;
Delay_ms(10);
PORTE.F1 = 0;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Alarma_on(){         // activacion del sistema de seguridad y configuracion e inicio de retardo de salida
alarma = 1;
retardo_s = 0;
retardo_a = 0;
retardo_e = 0;
PIE1.TMR1IE = 0;        // configuracion e inicializacion del modulo timer
cnt = 0;
P1 = 0;
E1 = 0;                 // inicializacion de variables
F1 = 0;
I1 = 0;
A1 = 0;
Clean_Buffer();
RxTx_Data[0] = '6'; // Sistema Armado
RxTx_Data[1] = '1'; // Sistema Armado
RxTx_Data[7] = '#'; // Envio a todos los modulos
RF_Write();
Led_Test();
Led_Test();
Led_Test();
Sirena_on();
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Alarma_off(){          // Desactivacion del sistema de seguridad
alarma = 0;
retardo_s = 0;
retardo_e = 0;
retardo_a = 0;
PIE1.TMR1IE = 0;          // Desactivacion del modulo timer y finalizacion de retardos
cnt = 0;
P1 = 0;
E1 = 0;
F1 = 0;
I1 = 0;
A1 = 0;
Clean_Buffer();
RxTx_Data[0] = '6'; // Sistema Armado
RxTx_Data[1] = '0'; // Sistema Armado
RxTx_Data[7] = '#'; // Envio a todos los modulos
RF_Write();
Led_Test();
Led_Test();
Sirena_off();
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Panico(){           // Rutina para envio de SMS de alarma de Panico
for (i = 0; i <= 24; i++)
    {
    Soft_Uart_Write(Send[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 17; i++)
    {
    Soft_Uart_Write(A_on[i]);
    }
Soft_Uart_Write('P');
Soft_Uart_Write('a');
Soft_Uart_Write('n');
Soft_Uart_Write('i');
Soft_Uart_Write('c');
Soft_Uart_Write('o');
Soft_Uart_Write(0x1A);
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Inundacion(){       // Rutina para envio de SMS de alarma de Inundacion
for (i = 0; i <= 24; i++)
    {
    Soft_Uart_Write(Send[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 17; i++)
    {
    Soft_Uart_Write(A_on[i]);
    }
Soft_Uart_Write('I');
Soft_Uart_Write('n');
Soft_Uart_Write('u');
Soft_Uart_Write('n');
Soft_Uart_Write('d');
Soft_Uart_Write('a');
Soft_Uart_Write('c');
Soft_Uart_Write('i');
Soft_Uart_Write('o');
Soft_Uart_Write('n');
Soft_Uart_Write(0x1A);
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Emergencia(){      // Rutina para envio de SMS de alarma de Emergencia
for (i = 0; i <= 24; i++)
    {
    Soft_Uart_Write(Send[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 17; i++)
    {
    Soft_Uart_Write(A_on[i]);
    }
Soft_Uart_Write('E');
Soft_Uart_Write('m');
Soft_Uart_Write('e');
Soft_Uart_Write('r');
Soft_Uart_Write('g');
Soft_Uart_Write('e');
Soft_Uart_Write('n');
Soft_Uart_Write('c');
Soft_Uart_Write('i');
Soft_Uart_Write('a');
Soft_Uart_Write(0x1A);
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Fuego(){      // Rutina para envio de SMS de alarma de Fuego
for (i = 0; i <= 24; i++)
    {
    Soft_Uart_Write(Send[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 17; i++)
    {
    Soft_Uart_Write(A_on[i]);
    }
Soft_Uart_Write('I');
Soft_Uart_Write('n');
Soft_Uart_Write('c');
Soft_Uart_Write('e');
Soft_Uart_Write('n');
Soft_Uart_Write('d');
Soft_Uart_Write('i');
Soft_Uart_Write('o');
Soft_Uart_Write(0x1A);
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Alarma(){            // Rutina para envio de SMS de alarma activada
for (i = 0; i <= 24; i++)
    {
    Soft_Uart_Write(Send[i]);
    }
Delay_ms(1000);
for (i = 0; i <= 17; i++)
    {
    Soft_Uart_Write(A_on[i]);
    }
Soft_Uart_Write('Z');
Soft_Uart_Write('o');
Soft_Uart_Write('n');
Soft_Uart_Write('a');
Soft_Uart_Write(':');
Soft_Uart_Write(' ');
Soft_Uart_Write(RxTx_Data[6]);
Soft_Uart_Write(' ');
Soft_Uart_Write('S');
Soft_Uart_Write('e');
Soft_Uart_Write('n');
Soft_Uart_Write('s');
Soft_Uart_Write('o');
Soft_Uart_Write('r');
Soft_Uart_Write(':');
Soft_Uart_Write(' ');
if (Sensores.F7 == 0)           // Envio en la estructura del SMS la zona y el sensor que fue activado
   {
   Soft_Uart_Write('8');
   Soft_Uart_Write(0x1A);
   return;
   }
if (Sensores.F6 == 0)
   {
   Soft_Uart_Write('7');
   Soft_Uart_Write(0x1A);
   return;
   }
if (Sensores.F5 == 0)
   {
   Soft_Uart_Write('6');
   Soft_Uart_Write(0x1A);
   return;
   }
if (Sensores.F4 == 0)
   {
   Soft_Uart_Write('5');
   Soft_Uart_Write(0x1A);
   return;
   }
if (Sensores.F3 == 0)
   {
   Soft_Uart_Write('4');
   Soft_Uart_Write(0x1A);
   return;
   }
if (Sensores.F2 == 0)
   {
   Soft_Uart_Write('3');
   Soft_Uart_Write(0x1A);
   return;
   }
if (Sensores.F1 == 0)
   {
   Soft_Uart_Write('2');
   Soft_Uart_Write(0x1A);
   return;
   }
if (Sensores.F0 == 0)
   {
   Soft_Uart_Write('1');
   Soft_Uart_Write(0x1A);
   return;
   }
Soft_Uart_Write(0x1A);
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Delete(){       //  Rutina para Eliminar un mensaje del modulo GSM
Led_Test();
for (i = 0; i <= 9; i++)
    {
    Soft_Uart_Write(Delete[i]);
    }
Delay_ms(1000);
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Decoder(){
Clean_Buffer();
RxTx_Data[0] = '1'; //          Comprobacion del SMS recibido, Zona, Actuador y Estado a modificar
RxTx_Data[1] = RxTx_SMS[3]; //
RxTx_Data[7] = RxTx_SMS[1]; //
if (RxTx_SMS[4] == 'A')
   {
   RxTx_Data[2] = '1'; //
   RF_Write();
   return;
   }
if (RxTx_SMS[4] == 'D')
   {
   RxTx_Data[2] = '0'; //
   RF_Write();
   return;
   }
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void SMS_Read(){       // Lectura del SMS recibido mediante USART por Software
Led_Test();
PORTD.F2 = 1;
for (i = 0; i <= 9; i++)        // Espera que el paquete sea recibido completamente
    {
    Soft_Uart_Write(Read[i]);
    }
i=0;
do{
  do {
     data = Soft_Uart_Read(recOK); //  Lectura de dato en USART por Software
     } while (*recOK);
  RxTx_SMS[i] = data;
  i++;
  }while(i <= 4);
PORTD.F2 = 0;
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Alarma_pwr(){      //Activacion de la salida para la Sirena o sistema final para indicar la activacion de la alarma
PORTD.F0 = 1;
PORTD.F0 = 1;
cnt = 0;
PIE1.TMR1IE = 1;       // Inicio de Temporizacion para activacion de salida de alarma
retardo_e = 0;
retardo_a = 1;
SMS_Alarma();
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Alarma_Up(){  // Rutina para detectar el comando de apertura de sensores desde modulos remotos
sensores = RxTx_Data[1];

if (((sensores.F7 == 0)||(sensores.F6 == 0))&&(A1 == 0))   //Determina el tipo de sensor remoto que se activo
   {
   retardo_e = 1;
   PIE1.TMR1IE = 1;
   A1 = 1;
   }
if (((sensores.F5 == 0)||(sensores.F4 == 0))&&(A1 == 0))
   {
   Alarma_pwr();
   A1 = 1;
   }
if ((sensores.F3 == 0)&&(P1 == 0))
   {
   SMS_Panico();
   P1 = 1;
   }
if ((sensores.F2 == 0)&&(I1 == 0))
   {
   SMS_Inundacion();
   I1 = 1;
   }
if ((sensores.F1 == 0)&&(E1 == 0))
   {
   SMS_Emergencia();
   E1 = 1;
   }
if ((sensores.F0 == 0)&&(F1 == 0))
   {
   SMS_Fuego();
   F1 = 1;
   }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Proceso_Privado (){
if ((RxTx_Data[0] == 0x30) && (alarma == 1))    //Un sensor activado
   {
   Alarma_Up();
   return;
   }
if (RxTx_Data[0] == 0x34)       // Activar alarma
   {
   if (RxTx_Data[1] == 0x31)         //on
       {
       Led_Test();
       retardo_s = 1;
       PIE1.TMR1IE = 1;
       cnt = 0;
       return;
       }
   if (RxTx_Data[1] == 0x30)        //off
       {
       Alarma_off();
       return;
       }
   }
if (RxTx_Data[0] == 0x35)      //Comprobacin del sistema
   {
   Led_Test();
   return;
   }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Proceso_Publico (){    // Proceso Publico no Habilitado
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Init()
{
ADCON1 = 0x0F;            // Configuracion de puerto analogico
PORTA = 0x00;
TRISA = 0xFF;
PORTB = 0x00;             // Configuracion de entradas y salidas digitales
TRISB = 0x00;
PORTD = 0x00;
TRISD = 0x80;
PORTE = 0x00;
TRISE = 0x00;
Usart_Init(9600);       // Inicializacion de USART
recOK = &ro;
Soft_Uart_Init(PORTD, 7, 6, 9600, 0);   // Inicializacion de USART por Software
ro = !ro;
INTCON.GIE = 1;
INTCON.PEIE = 1;
PIE1.TMR1IE = 0;         // Configuracion de Interrupciones por Timer y USART
IPR1.TMR1IP = 0;
PIR1.TMR1IF = 0;
PIE1.RCIE = 1;
PIR1.RCIF = 0;
T1CON=0xBD;
TMR1L = 30;
TMR1H = 30;
cnt=0;
retardo_s = 0;
retardo_a = 0;
retardo_e = 0;
Tx_ID = '1';     //********** Identificador de modulo
Private_ID = '1';     //********** Direccion Privada
Public_ID = '#';      //********** Direccion Publica
PORTB.F7 = 1;
for (i = 0; i <= 1; i++ )
    {
    Delay_ms(1000);
    }
PORTB.F7 = 0;
for (i = 0; i <= 4; i++ )    // Retardo para inicio del modulo GSM
    {
    Delay_ms(1000);
    }
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

void main()
{
Init();
Modem_Init();
Led_Test();
while(1) {
          if ((ID == Private_ID) && (Msg_Rcvd))   // Comprobacion de recepcion de paquete Privado
             {
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Delay_ms(30);
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Msg_Rcvd = 0;
             Proceso_Privado();
             }
          if ((ID == Public_ID) && (Msg_Rcvd))  // Comprobacion de recepcion de paquete Publico
             {
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Delay_ms(30);
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Msg_Rcvd = 0;
             Proceso_Publico();
             }                                 // Verificacion de Retardos
           if ((cnt >= 250)&&(retardo_s == 1))  // retado de salida
              {
              Alarma_On();
              }
           if ((cnt >= 150)&&(retardo_e == 1)) // retardo de entrada
              {
              Alarma_pwr();
              }
           if ((cnt >= 500)&&(retardo_a == 1)) // retardo de activacion de alarma
              {
              PORTD.F0 = 0;
              PIE1.TMR1IE = 0;
              cnt = 0;
              retardo_a = 0;
              }
           if(PORTA.F0 == 1)           // Entrada para deteccion de recepcion SMS
             {
             SMS_Read();
             SMS_Decoder();
             SMS_Delete();
             }
          }
}