//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//    Modulo Observer
//    Coutio Constancio Diana Lizzete
//
//
//
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Declaracion de variables--------------
unsigned char Rx_Data_Len;        // Longitud del el paquete recibido
char RxTx_Data[8];                // buffer para paquete de datos
unsigned short Msg_Rcvd;          // bandera de recepcion finalizada de datos
char Tx_ID, Rx_ID, Public_ID,Private_ID, ID;   // direccion de identificacion de modulo
unsigned short alerta = 0;          // bandera indicadora de sensor activado
unsigned short deteccion = 0xFF;
long tlong = 0;
unsigned int adc_rd = 0;
unsigned char ch = 0;
int cTx = 0;
int cRx = 0;
unsigned short activar = 0;
unsigned short salida = 0;
unsigned short alarma = 0;
unsigned short current_duty, old_duty;
int i = 0;
int sw = 0;
unsigned short sw0 = 0;          // banderas
unsigned short sw1 = 0;          // para
unsigned short sw2 = 0;          // determinacion
unsigned short sw3 = 0;          // de
unsigned short sw4 = 0;          // sensor
unsigned short sw5 = 0;          // activado
unsigned short sw6 = 0;
unsigned short sw7 = 0;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Interrupcin por recepcion de datos en USART-------------------
void interrupt() {
if((PIR1.RCIF == 1) && (RCSTA.OERR == 0) && (cRx <= 7))     // comprobacion de interrupcion por recepcion de datos en USART
  {
  PORTE.F0 = 1;
  RxTx_Data[cRx] =  Usart_Read();     // lectura de dato presente en el buffer de la USART
  cRx++;
  PORTE.F0 = 0;
  if (cRx == 8)                       // Comprobacion de finalizacion de paquete y activacion de sealizador de recepcion terminada
     {
     Msg_Rcvd = 1;
     Rx_ID = RxTx_Data[6];
     ID = RxTx_Data[7];
     cRx = 0;
     }
  PIR1.RCIF = 0;
  }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para status del sistema--------------
void Test(){
for (i = 0; i<= 1; i++)          // Generacion de un efecto de luces para indicacion de funcionamiento del sistema
    {
    PORTE.F0 = 1;
    Delay_ms(10);
    PORTE.F0 = 0;
    Delay_ms(30);
    PORTE.F0 = 1;
    Delay_ms(10);
    PORTE.F0 = 0;
    PORTE.F1 = 1;
    Delay_ms(10);
    PORTE.F1 = 0;
    Delay_ms(30);
    PORTE.F1 = 1;
    Delay_ms(10);
    PORTE.F1 = 0;
    PORTE.F2 = 1;
    Delay_ms(10);
    PORTE.F2 = 0;
    Delay_ms(30);
    PORTE.F2 = 1;
    Delay_ms(10);
    PORTE.F2 = 0;
    PORTE.F1 = 0;
    PORTE.F0 = 0;
    Delay_ms(500);
    }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para inicializacin del sistema--------------
void init (){
  ADCON1 = 0x09;            // Configuracion  de entradas analogicas
  TRISA = 0xFF;             //
  PORTB = 0x00;             //
  TRISB = 0xFF;             //
  PORTD = 0x00;             // Configuracion  de puertos digitales para
  TRISD = 0x00;             // entradas y salidas
  PORTE = 0x00;             //
  TRISE = 0x00;             //
  INTCON.GIE = 1;
  INTCON.PEIE = 1;          //  Configuracion de registros de interrupciones
  PIE1.RCIE = 1;            //  Interrupcion por USART
  PIR1.RCIF = 0;
  Usart_Init(9600);         // Inicializacion de Modulo USART
  PORTC.F1 = 0;
  TRISC.F1 = 0;
  PORTC.F2 = 0;
  TRISC.F2 = 0;
  Tx_ID = '3';              //********** Identificador de modulo
  Private_ID = '3';         //********** Direccion Privada
  Public_ID = '#';          //********** Direccion Publica
  PWM1_Init(5000);          // Inicializacion de Modulo PWM
  PWM1_Start();
  current_duty     = 0;
  old_duty    = 0;
  Test();
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para limpiar el Buffer de datos--------------
void Clean_Buffer(){
RxTx_Data[0] = 0;
RxTx_Data[1] = 0;
RxTx_Data[2] = 0;
RxTx_Data[3] = 0;
RxTx_Data[4] = 0;
RxTx_Data[5] = 0;
RxTx_Data[6] = 0;
RxTx_Data[7] = 0;
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

//------Rutina para envio de paquetes de datos--------------
void RF_Write (){
RxTx_Data[6] = Tx_ID;
for (cTx = 0; cTx <= 7; cTx++)   // Escritura de un paquete de datos al modulo USART
    {
    Usart_Write(RxTx_Data[cTx]);
    Delay_ms(5);
    }
cTX = 0;                        // Indicacion de envio de paquete de datos
PORTE.F1 = 1;
Delay_ms(10);
PORTE.F1 = 0;
Delay_ms(30);
PORTE.F1 = 1;
Delay_ms(10);
PORTE.F1 = 0;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina el control del estado de las salidas--------------
void Salidas (){
switch (RxTx_Data[1])     // Comprobacion de la salida a modificar respecto al paquete de datos
       {
       case 0x30: salida.F0 = RxTx_Data[2]-30;
                  break;
       case 0x31: salida.F1 = RxTx_Data[2]-30;
                  break;
       case 0x32: salida.F2 = RxTx_Data[2]-30;
                  break;
       case 0x33: salida.F3 = RxTx_Data[2]-30;
                  break;
       case 0x34: salida.F4 = RxTx_Data[2]-30;
                  break;
       case 0x35: salida.F5 = RxTx_Data[2]-30;
                  break;
       case 0x36: salida.F6 = RxTx_Data[2]-30;
                  break;
       case 0x37: salida.F7 = RxTx_Data[2]-30;
                  break;
       case 0x38: salida = 0xFF;
                  break;
       case 0x39: salida = 0x00;
                  break;
       default:   break;
      }
PORTD = salida;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para el control de la salida PWM--------------
void PWM_Write (){
switch (RxTx_Data[1])                              // incremento y decremento de salida PWM
       {
       case 0x30: current_duty = current_duty+5;
                  break;
       case 0x31: current_duty = current_duty-5;
                  break;
       default:   break;
       }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para envio del estado del modulo--------------
void Digital (){
Clean_Buffer();
RxTx_Data[1] = PORTB;     // Escritura del estado de entradas en Buffer
RxTx_Data[2] = PORTD;     // Escritura del estado de salidas en Buffer
RxTx_Data[3] = alerta;    // Escritura del estado de el indicador de eventos de alarma pasados
RxTx_Data[7] = Rx_ID;
RF_Write();
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para lectura de entradas analogicas--------------
void Analogico (){
adc_rd = ADC_read(RxTx_Data[2]-30);   // Lectura de datos analogico
tlong = (long)adc_rd * 1000000;
tlong = tlong / 2050;                 // Acondicionamiento en la resolucion de la lectura analogica
Clean_Buffer();
ch = tlong / 100000;                  // Separacion de caracteres para el envio al buffer
RxTx_Data[0] = ch+48;
ch = (tlong / 10000) % 10;
RxTx_Data[1] = ch+48;
ch =(tlong / 1000) % 10;
RxTx_Data[2] = ch+48;
RxTx_Data[3]  = '.';
ch = (tlong / 100) % 10;
RxTx_Data[4] = ch+48;
ch = (tlong / 10) % 10;
RxTx_Data[5] = ch+48;
RxTx_Data[7] = Rx_ID;
RF_Write();
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para lectura de entradas digitales--------------
void Sensores(){
Clean_Buffer();
if ((PORTB.F0 == 0)&&(sw0 == 0))       // Comprobacion del estado de una entrada digital para el envio de seal de alarma
   {
   alerta.F0 = 1;
   sw0 = 1;
   sw = 1;
   }
if ((PORTB.F0 == 1)&&(sw0 == 1))
   {
   sw0 = 0;
   }

if ((PORTB.F1 == 0)&&(sw1 == 0))
   {
   alerta.F1 = 1;
   sw1 = 1;
   sw = 1;
   }
if ((PORTB.F1 == 1)&&(sw1 == 1))
   {
   sw1 = 0;
   }
   
if ((PORTB.F2 == 0)&&(sw2 == 0))
   {
   alerta.F2 = 1;
   sw2 = 1;
   sw = 1;
   }
if ((PORTB.F2 == 1)&&(sw2 == 1))
   {
   sw2 = 0;
   }

if ((PORTB.F3 == 0)&&(sw3 == 0))
   {
   alerta.F3 = 1;
   sw3 = 1;
   sw = 1;
   }
if ((PORTB.F3 == 1)&&(sw3 == 1))
   {
   sw3 = 0;
   }

if ((PORTB.F4 == 0)&&(sw4 == 0))
   {
   alerta.F4 = 1;
   sw4 = 1;
   sw = 1;
   }
if ((PORTB.F4 == 1)&&(sw4 == 1))
   {
   sw4 = 0;
   }

if ((PORTB.F5 == 0)&&(sw5 == 0))
   {
   alerta.F5 = 1;
   sw5 = 1;
   sw = 1;
   }
if ((PORTB.F5 == 1)&&(sw5 == 1))
   {
   sw5 = 0;
   }
   
if ((PORTB.F6 == 0)&&(sw6 == 0))
   {
   alerta.F6 = 1;
   sw6 = 1;
   sw = 1;
   }
if ((PORTB.F6 == 1)&&(sw6 == 1))
   {
   sw6 = 0;
   }
   
if ((PORTB.F7 == 0)&&(sw7 == 0))
   {
   alerta.F7 = 1;
   sw7 = 1;
   sw = 1;
   }
if ((PORTB.F7 == 1)&&(sw7 == 1))
   {
   sw7 = 0;
   }

if ((alarma == 0x31)&&(sw == 1)&&(activar == 0x31))   // Envio de Seal de alarma si el sistema de alarma esta activado
   {
   Clean_Buffer();
   RxTx_Data[0] = '0';
   RxTx_Data[1] = PORTB;    // Envio de la seal de alarma mediante un paquete de datos con el estado de el puerto de entrada y el estado de eventos pasados de alarma
   RxTx_Data[2] = alerta;
   RxTx_Data[7] = '1';
   RF_Write ();
   sw = 0;
   }
return;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------Rutina para determinar el proceso que realizara unicamente este modulo-----
void Proceso_Privado (){
if (RxTx_Data[0] == 0x30)
   {
   switch (RxTx_Data[1])         // Comprueba si la peticion de datos es para entradas digitales o analogicas
          {
          case 0x31: Analogico();
                     break;
          case 0x32: Digital();
                     break;
          default: break;
          }
   return;
   }
if (RxTx_Data[0] == 0x31)    // Mofica el estado de las salidas
   {
   Salidas();
   return;
   }
if (RxTx_Data[0] == 0x32)    // Modifica la salida PWM
   {
   PWM_Write();
   return;
   }
if (RxTx_Data[0] == 0x33)   // Reinicia la variable Alerta
   {
   alerta = 0;
   return;
   }
if (RxTx_Data[0] == 0x34)    // Activa el sistema de seguridad
   {
   if ((RxTx_Data[1] == '1')&&(PORTB == 0xFF))   // Comprueba si todos los sensores se encuentran cerrados
      {
      alarma = RxTx_Data[1];
      alerta = 0;
      deteccion = 0xFF;
      RxTx_Data[5] = 'O';
      RxTx_Data[7] = Rx_ID;
      RF_Write ();                 // Envia Comprobacion de ativacion del sistema de seguridad
      Test();
      return;
      }
   if ((RxTx_Data[1] == '1')&&(PORTB != 0xFF))
      {
      Clean_Buffer();             // Envia un error si el sistema de seguridad no se puede activar
      RxTx_Data[5] = 'E';
      RxTx_Data[7] = Rx_ID;
      RF_Write ();
      Test();
      return;
      }
   if (RxTx_Data[1] == '0')     // Desactiva el sistema de seguridad
      {
      alarma = RxTx_Data[1];
      alerta = 0;
      Test();
      return;
      }
   }
if (RxTx_Data[0] == 0x35)      // Comprobacion remota del funcionamiento del sistema
   {
   Test();
   return;
   }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

// Rutina para Proceso de Operaciones que pueden realizar todos los modulos (Publico)

void Proceso_Publico (){
if (RxTx_Data[0] == 0x31)    // Modificacion de Salidas
   {
   Salidas();
   return;
   }
if (RxTx_Data[0] == 0x32)    // Modificar salida PWM
   {
   PWM_Write();
   return;
   }
if (RxTx_Data[0] == 0x33)    // Reinicio de variable de evetos pasados ( alerta )
   {
   alerta = 0;
   return;
   }
if (RxTx_Data[0] == 0x35)   // Comprobacion remota del sistema
   {
   Test();
   return;
   }
if (RxTx_Data[0] == 0x36)    // Autorizacion para activacion total del sistema de seguridad
   {
   activar = RxTx_Data[1];
   return;
   }
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void main() {
init();
while(1) {

          if (PORTB != deteccion)   // Determinacion del estado del puerto de entrada para detectar cambios
             {
             deteccion = PORTB;
             Sensores();
             }
             
          if ((ID == Private_ID) && (Msg_Rcvd))  // Verificacion de recepcion de paquete de datos para proceso privado
             {
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Delay_ms(30);
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Msg_Rcvd = 0;
             Proceso_Privado();
             }
          if ((ID == Public_ID) && (Msg_Rcvd)) // Verificacion de recepcion de paquete de datos para proceso publico
             {
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Delay_ms(30);
             PORTE.F2 = 1;
             Delay_ms(10);
             PORTE.F2 = 0;
             Msg_Rcvd = 0;
             Proceso_Publico();
             }


             PWM1_Change_Duty(current_duty);   // Actualizacion del estado de la salidad PWM
          }
}
