/////////////////////////////////////////////////////////////////////////
////                                                                 ////
////                    Modulo USB                                   ////
////          Coutio Constancio Diana Lizzete                       ////
/////////////////////////////////////////////////////////////////////////

#include <18F2550.h>
#fuses HSPLL,NOWDT,NOPROTECT,NOLVP,NODEBUG,USBDIV,PLL5,CPUDIV1,VREGEN
#use delay(clock=48000000)
#use rs232(BAUD=9600, XMIT=PIN_C6,RCV=PIN_C7,bits=1) 

//--------------------------------------------------------------------------

   char RX232, TX232;
//-------------------------------------------------------------------------

void FlashE (void);

//--------------------------------------------------------------------------

void main()
 {
 delay_ms(300); // Retardo para inicializacion de modulo USB
 usb_cdc_init(); // Inicializacion de Modulo USB
 usb_init();  // Deteccion de Dispositivo USB en PC
 
   while(!usb_cdc_connected()) // Espera a que el dispositivo sea reconocido por PC
        {
        FlashE();  
        }  
   do {
      output_bit(PIN_B5,1);
      usb_task();
      if (usb_enumerated()) // Espera a que el dispositivo sea enumerado por PC
         {
         if (usb_cdc_kbhit()) // Comprobacion de recepcion de dato por USB
            {
            TX232=usb_cdc_getc();
            output_bit( PIN_B4, 1); // Reenvio del dato recibido hacia modulo Xbee
            putc(TX232);
            output_bit( PIN_B4, 0);
            }
         if (kbhit())  // Recepcion de datos desde modulo Xbee
            {
            RX232=getchar();
            output_bit( PIN_B3, 1);
            usb_cdc_putc_fast(RX232); // Reenvio del dato recibido hacia puerto USB 
            output_bit( PIN_B3, 0);
            }     
         }
      } while (TRUE);
}

//---------------------------------------------------------------

void FlashE (void)  // Rutina para destello de led indicador de conexion a puerto USB
{
output_bit( PIN_B5, 1);
Delay_ms(10);
output_bit( PIN_B5, 0);
Delay_ms(30);
output_bit( PIN_B5, 1);
Delay_ms(10);
output_bit( PIN_B5, 0);
Delay_ms(700);
}


